package com.mycompany.springdemo.services;

import com.mycompany.springdemo.dao.PizzaOrderDAO;
import com.mycompany.springdemo.dao.PizzaOrderItemDAO;
import com.mycompany.springdemo.entities.PizzaOrder;
import com.mycompany.springdemo.entities.PizzaOrderItem;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * @author adamekp
 */
@Service
public class PizzaOrderServiceImpl implements PizzaOrderService {

	private PizzaOrderDAO pizzaOrderDAO;
	private PizzaOrderItemDAO pizzaOrderItemDAO;

	@Autowired
	public void setPizzaOrderDAO(PizzaOrderDAO pizzaOrderDAO) {
		this.pizzaOrderDAO = pizzaOrderDAO;
	}

	@Autowired
	public void setPizzaOrderItemDAO(PizzaOrderItemDAO pizzaOrderItemDAO) {
		this.pizzaOrderItemDAO = pizzaOrderItemDAO;
	}

	@Transactional
	public void createPizzaOrder(PizzaOrder pizzaOrder) {
		pizzaOrderDAO.create(pizzaOrder);
		for (PizzaOrderItem item : pizzaOrder.getItems()) {
			pizzaOrderItemDAO.create(item);
		}
	}

}
